﻿// Tamilnet99 key function definition starts

function tamilnet99key(keyCode, key) {

var tamilnet99keystrings = new Array()
// upper row
tamilnet99keystrings["q"]="ஆ";
tamilnet99keystrings["w"]="ஈ";
tamilnet99keystrings["e"]="ஊ";
tamilnet99keystrings["r"]="ஐ";
tamilnet99keystrings["t"]="ஏ";
tamilnet99keystrings["y"]="ள";
tamilnet99keystrings["u"]="ற";
tamilnet99keystrings["i"]="ன";
tamilnet99keystrings["p"]="ண";
tamilnet99keystrings["o"]="ட";
tamilnet99keystrings["["]="ச";
tamilnet99keystrings["]"]="ஞ";

tamilnet99keystrings["Q"]="ஸ";
tamilnet99keystrings["W"]="ஷ";
tamilnet99keystrings["E"]="ஜ";
tamilnet99keystrings["R"]="ஹ";
tamilnet99keystrings["T"]="T";
tamilnet99keystrings["Y"]="Y";
tamilnet99keystrings["O"]="[";
tamilnet99keystrings["P"]="]";


//middle row keys
tamilnet99keystrings["a"]="அ";
tamilnet99keystrings["s"]="இ";
tamilnet99keystrings["d"]="உ";
tamilnet99keystrings["g"]="எ";
tamilnet99keystrings["h"]="க";
tamilnet99keystrings["j"]="ப";
tamilnet99keystrings["k"]="ம";
tamilnet99keystrings["l"]="த";
tamilnet99keystrings[";"]="ந";
tamilnet99keystrings["\'"]="ய";

tamilnet99keystrings["F"]="ஃ";
tamilnet99keystrings["K"]="\"";
tamilnet99keystrings["L"]=":";


//bottom row keys
tamilnet99keystrings["z"]="ஔ";
tamilnet99keystrings["x"]="ஓ";
tamilnet99keystrings["c"]="ஒ";
tamilnet99keystrings["v"]="வ";
tamilnet99keystrings["b"]="ங";
tamilnet99keystrings["n"]="ல";
tamilnet99keystrings["m"]="ர";
tamilnet99keystrings["/"]="ழ";

tamilnet99keystrings["M"]="/";

// Mei ezhuthukal
tamilnet99keystrings["hf"]="க்"; 
tamilnet99keystrings["bf"]="ங்"; 
tamilnet99keystrings["[f"]="ச்"; 
tamilnet99keystrings["]f"]="ஞ்"; 
tamilnet99keystrings["of"]="ட்"; 
tamilnet99keystrings["pf"]="ண்"; 
tamilnet99keystrings["lf"]="த்"; 
tamilnet99keystrings[";f"]="ந்"; 
tamilnet99keystrings["jf"]="ப்"; 
tamilnet99keystrings["kf"]="ம்"; 
tamilnet99keystrings["'f"]="ய்"; 
tamilnet99keystrings["mf"]="ர்"; 
tamilnet99keystrings["nf"]="ல்"; 
tamilnet99keystrings["vf"]="வ்"; 
tamilnet99keystrings["/f"]="ழ்"; 
tamilnet99keystrings["yf"]="ள்"; 
tamilnet99keystrings["uf"]="ற்"; 
tamilnet99keystrings["if"]="ன்";
tamilnet99keystrings["Qf"]="ஸ்";
tamilnet99keystrings["Wf"]="ஷ்";
tamilnet99keystrings["Ef"]="ஜ்";
tamilnet99keystrings["Rf"]="ஹ்";
tamilnet99keystrings["Tf"]="க்ஷ்";
 
// aa-garam
tamilnet99keystrings["hq"]="கா"; 
tamilnet99keystrings["bq"]="ஙா"; 
tamilnet99keystrings["[q"]="சா"; 
tamilnet99keystrings["]q"]="ஞா"; 
tamilnet99keystrings["oq"]="டா"; 
tamilnet99keystrings["pq"]="ணா"; 
tamilnet99keystrings["lq"]="தா"; 
tamilnet99keystrings[";q"]="நா"; 
tamilnet99keystrings["jq"]="பா"; 
tamilnet99keystrings["kq"]="மா"; 
tamilnet99keystrings["'q"]="யா"; 
tamilnet99keystrings["mq"]="ரா"; 
tamilnet99keystrings["nq"]="லா"; 
tamilnet99keystrings["vq"]="வா"; 
tamilnet99keystrings["/q"]="ழா"; 
tamilnet99keystrings["yq"]="ளா"; 
tamilnet99keystrings["uq"]="றா"; 
tamilnet99keystrings["iq"]="னா";
tamilnet99keystrings["Qq"]="ஸா";
tamilnet99keystrings["Wq"]="ஷா";
tamilnet99keystrings["Eq"]="ஜா";
tamilnet99keystrings["Rq"]="ஹா";
tamilnet99keystrings["Tq"]="க்ஷா";

// i-garam
tamilnet99keystrings["hs"]="கி"; 
tamilnet99keystrings["bs"]="ஙி"; 
tamilnet99keystrings["[s"]="சி"; 
tamilnet99keystrings["]s"]="ஞி"; 
tamilnet99keystrings["os"]="டி"; 
tamilnet99keystrings["ps"]="ணி"; 
tamilnet99keystrings["ls"]="தி"; 
tamilnet99keystrings[";s"]="நி"; 
tamilnet99keystrings["js"]="பி"; 
tamilnet99keystrings["ks"]="மி"; 
tamilnet99keystrings["'s"]="யி"; 
tamilnet99keystrings["ms"]="ரி"; 
tamilnet99keystrings["ns"]="லி"; 
tamilnet99keystrings["vs"]="வி"; 
tamilnet99keystrings["/s"]="ழி"; 
tamilnet99keystrings["ys"]="ளி"; 
tamilnet99keystrings["us"]="றி"; 
tamilnet99keystrings["is"]="னி";
tamilnet99keystrings["Qs"]="ஸி";
tamilnet99keystrings["Ws"]="ஷி";
tamilnet99keystrings["Es"]="ஜி";
tamilnet99keystrings["Rs"]="ஹி";
tamilnet99keystrings["Ts"]="க்ஷி";

// ii-garam
tamilnet99keystrings["hw"]="கீ"; 
tamilnet99keystrings["bw"]="ஙீ"; 
tamilnet99keystrings["[w"]="சீ"; 
tamilnet99keystrings["]w"]="ஞீ"; 
tamilnet99keystrings["ow"]="டீ"; 
tamilnet99keystrings["pw"]="ணீ"; 
tamilnet99keystrings["lw"]="தீ"; 
tamilnet99keystrings[";w"]="நீ"; 
tamilnet99keystrings["jw"]="பீ"; 
tamilnet99keystrings["kw"]="மீ"; 
tamilnet99keystrings["'w"]="யீ"; 
tamilnet99keystrings["mw"]="ரீ"; 
tamilnet99keystrings["nw"]="லீ"; 
tamilnet99keystrings["vw"]="வீ"; 
tamilnet99keystrings["/w"]="ழீ"; 
tamilnet99keystrings["yw"]="ளீ"; 
tamilnet99keystrings["uw"]="றீ"; 
tamilnet99keystrings["iw"]="னீ";
tamilnet99keystrings["Qw"]="ஸீ";
tamilnet99keystrings["Ww"]="ஷீ";
tamilnet99keystrings["Ew"]="ஜீ";
tamilnet99keystrings["Rw"]="ஹீ";
tamilnet99keystrings["Tw"]="க்ஷீ";

// u-garam
tamilnet99keystrings["hd"]="கு"; 
tamilnet99keystrings["bd"]="ஙு"; 
tamilnet99keystrings["[d"]="சு"; 
tamilnet99keystrings["]d"]="ஞு"; 
tamilnet99keystrings["od"]="டு"; 
tamilnet99keystrings["pd"]="ணு"; 
tamilnet99keystrings["ld"]="து"; 
tamilnet99keystrings[";d"]="நு"; 
tamilnet99keystrings["jd"]="பு"; 
tamilnet99keystrings["kd"]="மு"; 
tamilnet99keystrings["'d"]="யு"; 
tamilnet99keystrings["md"]="ரு"; 
tamilnet99keystrings["nd"]="லு"; 
tamilnet99keystrings["vd"]="வு"; 
tamilnet99keystrings["/d"]="ழு"; 
tamilnet99keystrings["yd"]="ளு"; 
tamilnet99keystrings["ud"]="று"; 
tamilnet99keystrings["id"]="னு";
tamilnet99keystrings["Qd"]="ஸு";
tamilnet99keystrings["Wd"]="ஷு";
tamilnet99keystrings["Ed"]="ஜு";
tamilnet99keystrings["Rd"]="ஹு";
tamilnet99keystrings["Td"]="க்ஷு";

// uu-garam
tamilnet99keystrings["he"]="கூ"; 
tamilnet99keystrings["be"]="ஙூ"; 
tamilnet99keystrings["[e"]="சூ"; 
tamilnet99keystrings["]e"]="ஞூ"; 
tamilnet99keystrings["oe"]="டூ"; 
tamilnet99keystrings["pe"]="ணூ"; 
tamilnet99keystrings["le"]="தூ"; 
tamilnet99keystrings[";e"]="நூ"; 
tamilnet99keystrings["je"]="பூ"; 
tamilnet99keystrings["ke"]="மூ"; 
tamilnet99keystrings["'e"]="யூ"; 
tamilnet99keystrings["me"]="ரூ"; 
tamilnet99keystrings["ne"]="லூ"; 
tamilnet99keystrings["ve"]="வூ"; 
tamilnet99keystrings["/e"]="ழூ"; 
tamilnet99keystrings["ye"]="ளூ"; 
tamilnet99keystrings["ue"]="றூ"; 
tamilnet99keystrings["ie"]="னூ";
tamilnet99keystrings["Qe"]="ஸூ";
tamilnet99keystrings["We"]="ஷூ";
tamilnet99keystrings["Ee"]="ஜூ";
tamilnet99keystrings["Re"]="ஹூ";
tamilnet99keystrings["Te"]="க்ஷூ";

// e-garam
tamilnet99keystrings["hg"]="கெ"; 
tamilnet99keystrings["bg"]="ஙெ"; 
tamilnet99keystrings["[g"]="செ"; 
tamilnet99keystrings["]g"]="ஞெ"; 
tamilnet99keystrings["og"]="டெ"; 
tamilnet99keystrings["pg"]="ணெ"; 
tamilnet99keystrings["lg"]="தெ"; 
tamilnet99keystrings[";g"]="நெ"; 
tamilnet99keystrings["jg"]="பெ"; 
tamilnet99keystrings["kg"]="மெ"; 
tamilnet99keystrings["'g"]="யெ"; 
tamilnet99keystrings["mg"]="ரெ"; 
tamilnet99keystrings["ng"]="லெ"; 
tamilnet99keystrings["vg"]="வெ"; 
tamilnet99keystrings["/g"]="ழெ"; 
tamilnet99keystrings["yg"]="ளெ"; 
tamilnet99keystrings["ug"]="றெ"; 
tamilnet99keystrings["ig"]="னெ";
tamilnet99keystrings["Qg"]="ஸெ";
tamilnet99keystrings["Wg"]="ஷெ";
tamilnet99keystrings["Eg"]="ஜெ";
tamilnet99keystrings["Rg"]="ஹெ";
tamilnet99keystrings["Tg"]="க்ஷெ";

// ee-garam
tamilnet99keystrings["ht"]="கே"; 
tamilnet99keystrings["bt"]="ஙே"; 
tamilnet99keystrings["[t"]="சே"; 
tamilnet99keystrings["]t"]="ஞே"; 
tamilnet99keystrings["ot"]="டே"; 
tamilnet99keystrings["pt"]="ணே"; 
tamilnet99keystrings["lt"]="தே"; 
tamilnet99keystrings[";t"]="நே"; 
tamilnet99keystrings["jt"]="பே"; 
tamilnet99keystrings["kt"]="மே"; 
tamilnet99keystrings["'t"]="யே"; 
tamilnet99keystrings["mt"]="ரே"; 
tamilnet99keystrings["nt"]="லே"; 
tamilnet99keystrings["vt"]="வே"; 
tamilnet99keystrings["/t"]="ழே"; 
tamilnet99keystrings["yt"]="ளே"; 
tamilnet99keystrings["ut"]="றே"; 
tamilnet99keystrings["it"]="னே";
tamilnet99keystrings["Qt"]="ஸே";
tamilnet99keystrings["Wt"]="ஷே";
tamilnet99keystrings["Et"]="ஜே";
tamilnet99keystrings["Rt"]="ஹே";
tamilnet99keystrings["Tt"]="க்ஷே";

// ai-garam
tamilnet99keystrings["hr"]="கை"; 
tamilnet99keystrings["br"]="ஙை"; 
tamilnet99keystrings["[r"]="சை"; 
tamilnet99keystrings["]r"]="ஞை"; 
tamilnet99keystrings["or"]="டை"; 
tamilnet99keystrings["pr"]="ணை"; 
tamilnet99keystrings["lr"]="தை"; 
tamilnet99keystrings[";r"]="நை"; 
tamilnet99keystrings["jr"]="பை"; 
tamilnet99keystrings["kr"]="மை"; 
tamilnet99keystrings["'r"]="யை"; 
tamilnet99keystrings["mr"]="ரை"; 
tamilnet99keystrings["nr"]="லை"; 
tamilnet99keystrings["vr"]="வை"; 
tamilnet99keystrings["/r"]="ழை"; 
tamilnet99keystrings["yr"]="ளை"; 
tamilnet99keystrings["ur"]="றை"; 
tamilnet99keystrings["ir"]="னை";
tamilnet99keystrings["Qr"]="ஸை";
tamilnet99keystrings["Wr"]="ஷை";
tamilnet99keystrings["Er"]="ஜை";
tamilnet99keystrings["Rr"]="ஹை";
tamilnet99keystrings["Tr"]="க்ஷை";

// o-garam
tamilnet99keystrings["hc"]="கொ"; 
tamilnet99keystrings["bc"]="ஙொ"; 
tamilnet99keystrings["[c"]="சொ"; 
tamilnet99keystrings["]c"]="ஞொ"; 
tamilnet99keystrings["oc"]="டொ"; 
tamilnet99keystrings["pc"]="ணொ"; 
tamilnet99keystrings["lc"]="தொ"; 
tamilnet99keystrings[";c"]="நொ"; 
tamilnet99keystrings["jc"]="பொ"; 
tamilnet99keystrings["kc"]="மொ"; 
tamilnet99keystrings["'c"]="யொ"; 
tamilnet99keystrings["mc"]="ரொ"; 
tamilnet99keystrings["nc"]="லொ"; 
tamilnet99keystrings["vc"]="வொ"; 
tamilnet99keystrings["/c"]="ழொ"; 
tamilnet99keystrings["yc"]="ளொ"; 
tamilnet99keystrings["uc"]="றொ"; 
tamilnet99keystrings["ic"]="னொ";
tamilnet99keystrings["Qc"]="ஸொ";
tamilnet99keystrings["Wc"]="ஷொ";
tamilnet99keystrings["Ec"]="ஜொ";
tamilnet99keystrings["Rc"]="ஹொ";
tamilnet99keystrings["Tc"]="க்ஷொ";

// oo-garam
tamilnet99keystrings["hx"]="கோ"; 
tamilnet99keystrings["bx"]="ஙோ"; 
tamilnet99keystrings["[x"]="சோ"; 
tamilnet99keystrings["]x"]="ஞோ"; 
tamilnet99keystrings["ox"]="டோ"; 
tamilnet99keystrings["px"]="ணோ"; 
tamilnet99keystrings["lx"]="தோ"; 
tamilnet99keystrings[";x"]="நோ"; 
tamilnet99keystrings["jx"]="போ"; 
tamilnet99keystrings["kx"]="மோ"; 
tamilnet99keystrings["'x"]="யோ"; 
tamilnet99keystrings["mx"]="ரோ"; 
tamilnet99keystrings["nx"]="லோ"; 
tamilnet99keystrings["vx"]="வோ"; 
tamilnet99keystrings["/x"]="ழோ"; 
tamilnet99keystrings["yx"]="ளோ"; 
tamilnet99keystrings["ux"]="றோ"; 
tamilnet99keystrings["ix"]="னோ";
tamilnet99keystrings["Qx"]="ஸோ";
tamilnet99keystrings["Wx"]="ஷோ";
tamilnet99keystrings["Ex"]="ஜோ";
tamilnet99keystrings["Rx"]="ஹோ";
tamilnet99keystrings["Tx"]="க்ஷோ";

// au-garam
tamilnet99keystrings["hz"]="கௌ"; 
tamilnet99keystrings["bz"]="ஙௌ"; 
tamilnet99keystrings["[z"]="சௌ"; 
tamilnet99keystrings["]z"]="ஞௌ"; 
tamilnet99keystrings["oz"]="டௌ"; 
tamilnet99keystrings["pz"]="ணௌ"; 
tamilnet99keystrings["lz"]="தௌ"; 
tamilnet99keystrings[";z"]="நௌ"; 
tamilnet99keystrings["jz"]="பௌ"; 
tamilnet99keystrings["kz"]="மௌ"; 
tamilnet99keystrings["'z"]="யௌ"; 
tamilnet99keystrings["mz"]="ரௌ"; 
tamilnet99keystrings["nz"]="லௌ"; 
tamilnet99keystrings["vz"]="வௌ"; 
tamilnet99keystrings["/z"]="ழௌ"; 
tamilnet99keystrings["yz"]="ளௌ"; 
tamilnet99keystrings["uz"]="றௌ"; 
tamilnet99keystrings["iz"]="னௌ";
tamilnet99keystrings["Qz"]="ஸௌ";
tamilnet99keystrings["Wz"]="ஷௌ";
tamilnet99keystrings["Ez"]="ஜௌ";
tamilnet99keystrings["Rz"]="ஹௌ";
tamilnet99keystrings["Tz"]="க்ஷௌ";

// double mei ezhuthukkal
tamilnet99keystrings["hh"]="க்க";
tamilnet99keystrings["bb"]="ங்ங";
tamilnet99keystrings["[["]="ச்ச";
tamilnet99keystrings["]]"]="ஞ்ஞ";
tamilnet99keystrings["oo"]="ட்ட";
tamilnet99keystrings["pp"]="ண்ண";
tamilnet99keystrings["ll"]="த்த";
tamilnet99keystrings[";;"]="ந்ந";
tamilnet99keystrings["jj"]="ப்ப";
tamilnet99keystrings["kk"]="ம்ம";
tamilnet99keystrings["''"]="ய்ய";
tamilnet99keystrings["mm"]="ர்ர";
tamilnet99keystrings["nn"]="ல்ல";
tamilnet99keystrings["vv"]="வ்வ";
tamilnet99keystrings["//"]="ழ்ழ";
tamilnet99keystrings["yy"]="ள்ள";
tamilnet99keystrings["uu"]="ற்ற";
tamilnet99keystrings["ii"]="ன்ன";
tamilnet99keystrings["QQ"]="ஸ்ஸ";
tamilnet99keystrings["WW"]="ஷ்ஷ";
tamilnet99keystrings["EE"]="ஜ்ஜ";
tamilnet99keystrings["RR"]="ஹ்ஹ";


//initialising the variables
remove_previous_key = "No";
key_string_matched = "No";
key_temp1 = "~";
key_temp2 = "~";
key_temp3 = "~";
key_temp4 = "~";


if ((prevkey_1)&&(prevkey_2)&&(prevkey_3)&&(prevkey_4)){
	key_temp4 = String.fromCharCode(prevkey_4) + String.fromCharCode(prevkey_3) + String.fromCharCode(prevkey_2) + String.fromCharCode(prevkey_1) + key;
}
if ((prevkey_1)&&(prevkey_2)&&(prevkey_3)){
	key_temp3 = String.fromCharCode(prevkey_3) + String.fromCharCode(prevkey_2) + String.fromCharCode(prevkey_1) + key;
}
if ((prevkey_1)&&(prevkey_2)){
	key_temp2 = String.fromCharCode(prevkey_2) + String.fromCharCode(prevkey_1) + key;
}
if (prevkey_1){
	key_temp1 = String.fromCharCode(prevkey_1) + key;
}

//alert("key_temp1 " + key_temp1);
//alert("key_temp2 " + key_temp2);
//alert("key_temp3 " + key_temp3);
//alert("key_temp4 " + key_temp4); 

if (key_temp4 != '~'){
status_temp = tamilnet99keystrings[key_temp4];
status_undefined = tamilnet99keystrings['something not in the array']; 
	if ((status_temp != status_undefined)){
			if( (prevkey_2==prevkey_1)&&(prevkey_1==keyCode)){
			remove_previous_key = "No";
			key_temp4 = '~';
		}
		else {
			key = key_temp4;
			remove_previous_key = "Yes";
		}
	}
	else {
	key_temp4 = '~';
	}
}

if ((key_temp4 == '~')&&(key_temp3 != '~')&&(remove_previous_key == "No")){
status_temp = tamilnet99keystrings[key_temp3];
status_undefined = tamilnet99keystrings['something not in the array']; 
	if ((status_temp != status_undefined)){
			if( (prevkey_2==prevkey_1)&&(prevkey_1==keyCode)){
			remove_previous_key = "No";
			key_temp3 = '~';
			}
			else {
			key = key_temp3;
			remove_previous_key = "Yes";
			}
	}
	else {
	key_temp3 = '~';
	}
}


if ((key_temp4 == '~')&&(key_temp3 == '~')&&(key_temp2 != '~')&&(remove_previous_key == "No")){
status_temp = tamilnet99keystrings[key_temp2];
status_undefined = tamilnet99keystrings['something not in the array']; 
	if ((status_temp != status_undefined)){
		if((prevkey_2==prevkey_1)&&(prevkey_1==keyCode)){
		remove_previous_key = "No";
		key_temp2='~';
		} else {
			key = key_temp2;
			remove_previous_key = "Yes";
		}
	}
	else {
		key_temp2 = '~';
	}
}

if ((key_temp4 == '~')&&(key_temp3 == '~')&&(key_temp2 == '~')&&(key_temp1 != '~')&&(remove_previous_key == "No")){
status_temp = tamilnet99keystrings[key_temp1];
status_undefined = tamilnet99keystrings['something not in the array']; 
	if ((status_temp != status_undefined)){
		if( (prevkey_2==prevkey_1)&&(prevkey_1==keyCode)){
			remove_previous_key = "No";
			key_temp1='~';
			prevkey_1='';
			prevkey_2='';
			prevkey_3='';
		}
		else {
			key = key_temp1;
			remove_previous_key = "Yes";
		}
	}
	else {
	key_temp1 = '~';
	}
}

//alert("key " +key);
//alert("remove prev key " + remove_previous_key);

//moving the keys to the previous positions 
	prevkey_4 = prevkey_3;
	prevkey_3 = prevkey_2;
	prevkey_2 = prevkey_1;
	prevkey_1 = keyCode;

var newkeycode1 = tamilnet99keystrings[key].charCodeAt();

if (tamilnet99keystrings[key] != status_undefined  ){
   	return { replaceKey: true,
            newKeyCode: newkeycode1,
            newKey: tamilnet99keystrings[key] };
 }
else {	
	return { cancelKey: false };
 }

} // tamilnet99key function definition ends

